// eslint-disable-next-line no-redeclare
var Ext = require('./adapter.js').Ext;

require('../../src/Promise.js');

// See https://github.com/promises-aplus/promises-tests

module.exports = {
    deferred: function() {
        // console.log('deferred called');
        var impl = {};

        impl.promise = new Ext.Promise(function(resolve, reject) {
            impl.resolve = function(value) {
                resolve(value);
            };

            impl.reject = function(reason) {
                reject(reason);
            };
        });

        // console.log('deferred created');
        return impl;
    },

    resolved: function(value) {
        // console.log('resolved called: ' + value);
        var ret = Ext.Promise.resolve(value);

        // console.log('resolved created ' + ret.then);
        return ret;
    },

    rejected: function(reason) {
        // console.log('rejected called: ' + reason);
        var ret = Ext.Promise.reject(reason);

        // console.log('rejected created: ' + reason);
        return ret;
    }
};
